var CELL_SIZE = 30,MAP_WIDTH = null,MAP_HEIGHT = null;

function SetMapSize(size) {
	var map = jQuery("#map_container");
	size = Math.min(100,Math.max(10,size));
	var npx = map[0].style.left.slice(0,-2) - 0;
	npx += ( CELL_SIZE - size) / 2 * MAP_WIDTH;
	npx = Math.max(0,npx);
	map[0].style.left = npx + "px";

	npx = map[0].style.top.slice(0,-2) - 0;
	npx += ( CELL_SIZE - size) / 2 * MAP_HEIGHT;
	npx = Math.max(0,npx);
	map[0].style.top = npx + "px";

	map[0].style.fontSize = Math.floor(size / 3) + "px";

	map[0].style.width = (size * MAP_WIDTH)+"px";
	map[0].style.height =(size * MAP_HEIGHT)+"px";
	CELL_SIZE = size;
}

function MakeMap(file,width,height,hex_mode) {
	MAP_WIDTH = width;
	MAP_HEIGHT = height;
	
	var map = $("#map"),tr,td;
	while (child = map[0].firstChild) map[0].removeChild(child);

	if (true !== hex_mode) {
		map.removeClass('hex').addClass('formal');
		for (var yc=0;yc<MAP_HEIGHT;yc++) {
			tr = document.createElement("tr");
			tr = $(tr);
			for (var xc=0;xc<MAP_WIDTH;xc++) {
				td = tr.append("<td class=\"mapcell x_"+xc+"\">"+xc+"-"+yc+"</td>");
			}
			map[0].appendChild(tr[0]);
		}
	} else {
		map.removeClass('formal').addClass('hex');
		for (var yc=0;yc<MAP_HEIGHT * 2;yc++) {
			tr = document.createElement("tr");
			tr = $(tr);
			for (var xc=0;xc<MAP_WIDTH;xc++) {
				if (0 === ((xc + yc) & 1)) {
					if (yc < MAP_HEIGHT * 2 - 1) {
						tr.append("<td class=\"mapcell x_"+xc+"\"><span>"+xc+"-"+Math.floor(yc / 2)+"</span></td>");
					} else {
						tr.append("<td>&nbsp;</td>");
					}
				} else {
					tr.append("<td class=\"mapcell x_"+xc+"\"></td>");
				}
			}
			map[0].appendChild(tr[0]);
		}
	}
	map[0].style.backgroundImage="url("+file+")";
}

$().ready(function () {
	MakeMap("feeld001.gif",20,20,true);
	SetMapSize(CELL_SIZE);

	map = jQuery("#map_container");
	map[0].style.width = (CELL_SIZE * MAP_WIDTH)+"px";
	map[0].style.height =(CELL_SIZE * MAP_HEIGHT)+"px";
	map.draggable({
		start: function( event, ui ) {document.activeElement.blur();},
		cancel : 'img'
	});

	var mousewheelevent = 'onwheel' in document ? 'wheel' : 'onmousewheel' in document ? 'mousewheel' : 'DOMMouseScroll';
	$(map).on(mousewheelevent,function(e){
		e.preventDefault();
		var delta = e.originalEvent.deltaY ? -(e.originalEvent.deltaY) : e.originalEvent.wheelDelta ? e.originalEvent.wheelDelta : -(e.originalEvent.detail);
		if (delta < 0){
			SetMapSize(CELL_SIZE - 2);
		} else {
			SetMapSize(CELL_SIZE + 2);
		}
		if ('function' === typeof reloadMapChip) {
			reloadMapChip();
		}
	});

	if ('function' === typeof reloadMapChip) {
		reloadMapChip();
	}
	
	$("#mapplacer_container").dialog({
		autoOpen: true,
		modal:true,
		width:600,
		buttons: {
			'追加': function() {
				if (jQuery('#unitplacer_name').val() == '') {
					return false;
				}
				jQuery( this ) . dialog( 'close' );
			},
			'キャンセル': function() {
				jQuery( this ) . dialog( 'close' );
			}
		}
	});
});

$().contextMenu({
	selector : '#map_container',
	callback: MapMenuCallback,
	items: {
		"1": {name: "コマを追加する", icon: ""},
		"2": '----',
		"3": {name: "マップを変更する", icon: ""},
	}
});

function MapMenuCallback (key, options) {
	if (key == 1) {
		$("#unitplacer_container").dialog('open');
		dialoggrid.setColumns(dialoggrid.getColumns());
	} else if (key == 3) {
		// Map Changes
	}
}
