
  function LifeFormatter(row, cell, value, columnDef, dataContext) {
    var color,data = dataContext[columnDef.field] / Math.max(dataContext['/' + columnDef.field],1) * 100;
	var color;
	
	if (data < 0) {
		var bkc;
		if (- data < 50) {
			return "<span class='life-bar' style='background:#ccc;width:" + (- data * 2) + "%'></span><span style='position:absolute;left:1em;'>" + dataContext[columnDef.field] + "/" + dataContext['/' + columnDef.field] + "</span>";
    	} else if( -data <= 100) {
			color = "#999";
			bkc = "#ccc";
			data = - data * 2 - 100;
		} else if( -data <= 150) {
			data = - data * 2 - 200;
			color = "#000";
			bkc = "#999";
		} else if( -data <= 150) {
			data = - data * 2 - 300;
			color = "#a00";
			bkc = "#000";
		} else {
			return "<span style='position:absolute;left:1em;'>" + dataContext[columnDef.field] + "/" + dataContext['/' + columnDef.field] + "</span>";
		}
		return "<span class='life-bar' style='background:" + bkc +";width:100%'></span><span class='life-bar' style='background:" + color + ";width:" + (data) + "%'></span><span style='position:absolute;left:1em;'>" + dataContext[columnDef.field] + "/" + dataContext['/' + columnDef.field] + "</span>";
	}
	
    if (data <= 25) {
      color = "#cc4444";
    } else if (data <= 50) {
      color = "#cccc00";
    } else if (data <= 75) {
      color = "#44cc44";
    } else {
      color = "#44cccc";
    }

    return "<span class='life-bar' style='background:" + color + ";width:" + data + "%'></span><span style='position:absolute;left:1em;'>" + dataContext[columnDef.field] + "/" + dataContext['/' + columnDef.field] + "</span>";
  }

  function LifeEditor(args) {
    var $from, $to, $picker, $max;
    var scope = this;
  
	this.Num = function(text) {
		if (text === '' || text === void(0)) {
			return 0;
		} else {
			return parseInt(text.replace(/[０-９]/g,function(s){return String.fromCharCode(s.charCodeAt(0)-0xFEE0)}),10);
		}
	}

    this.init = function () {
	  
      $from = $("<INPUT type='text' class='editor-life-from' />")
          .appendTo(args.container)
          .bind("keydown", scope.handleKeyDown);

      $(args.container).append("&nbsp;/&nbsp;");

      $to = $("<INPUT type=text class='editor-life-to' />")
          .appendTo(args.container)
          .bind("keydown", scope.handleKeyDown);
	  
	  $picker = $("<div class='editor-life-helper'><div class='editor-life-wrapper'><div class='editor-life-buttons'><button>+1</button><button>-1</button><button>MAX</button><br /><button>+5</button><button>-5</button><br /><button>+10</button><button>-10</button></div></div></div>");
      $picker.find(".editor-life-buttons button").bind("click", function (e) {
        if ($(this).text() === 'MAX') {
			$from.val($to.val());
		} else if ($(this).text() === 'CHG') {
			$from.focus();
		} else if ($max.text() === 'MAX'){
			$from.val(parseInt($(this).text(),10) + scope.Num($from.val()));
			$from.focus();
		} else {
			$to.val(parseInt($(this).text(),10) + scope.Num($to.val()));
			$to.focus();
		}
      });
	  $picker.bind("click", function (e) {
	  if(! $(e.target).is("button")){
	    args.commitChanges();
		args.cancelChanges();
	  }
	  });
	  $picker.appendTo(args.container);
	  $max = $picker.find("button").eq(2);
	  $from.bind("focus",function(e) { $max.text('MAX') });
	  $to.bind("focus",function(e) { $max.text('CHG') });
	  
      scope.focus();
    };

    this.handleKeyDown = function (e) {
	  if (e.keyCode == $.ui.keyCode.TAB && $to.is(':focus')) {
		$from.focus();
		$from[0].setSelectionRange(0, $from.val().length);
		e.stopImmediatePropagation();
		return false;
	  }
      if (e.keyCode == $.ui.keyCode.LEFT || e.keyCode == $.ui.keyCode.RIGHT || e.keyCode == $.ui.keyCode.TAB) {
        e.stopImmediatePropagation();
      }
    };

    this.destroy = function () {
      $(args.container).empty();
      $picker.remove();
      $from.remove();
      $to.remove();
    };

    this.focus = function () {
      $from.focus();
    };

    this.serializeValue = function () {
      return {from: scope.Num($from.val()), to: scope.Num($to.val())};
    };

    this.applyValue = function (item, state) {
      item[args.column.field] = state.from;
      item['/' + args.column.field] = state.to;
    };

    this.loadValue = function (item) {
      $from.val(item[args.column.field]);
      $to.val(item['/' + args.column.field]);
    };

    this.isValueChanged = function () {
      return args.item[args.column.field] != scope.Num($from.val()) || args.item['/' + args.column.field] != scope.Num($to.val());
    };

    this.validate = function () {
	  if (isNaN(scope.Num($from.val())) || isNaN(scope.Num($to.val()))) {
      	return {valid: false, msg: "数字でない文字が入力されました"};
      }
      return {valid: true, msg: null};
    };

    this.init();
  }
  
  function AutocheckEditor(args) {
    var $select;
    var defaultValue;
    var scope = this;

    this.init = function () {
      $select = $("<img src='../images/tick.png'>");
      $select.appendTo(args.container);
	  $(args.container).on('click.Autocheck-editor',function(e) { $select[0].style.display = ($select[0].style.display == 'none')?'':'none'; });
    };

    this.destroy = function () {
	  $(args.container).off('click.Autocheck-editor');
	  $select.remove();
    };

    this.focus = function () {
		args.commitChanges();
    };

    this.loadValue = function (item) {
      defaultValue = !!item[args.column.field];
	  if (defaultValue) {
		$select[0].style.display= 'none';
	  } else {
		$select[0].style.display = '';
	  }
    };

    this.serializeValue = function () {
      return ($select[0].style.display === '');
    };

    this.applyValue = function (item, state) {
      item[args.column.field] = state;
    };

    this.isValueChanged = function () {
      return defaultValue !== this.serializeValue();
    };

    this.validate = function () {
      return {
        valid: true,
        msg: null
      };
    };

    this.init();
  }
