  function ParamFormatter(row, cell, value, columnDef, dataContext) {
	var $now = dataContext[columnDef.field],$max = dataContext['/' + columnDef.field];
	if (void(0) === $now) {
		$now = 0;
	}
	if (void(0) === $max) {
		$max = 0;
	}
	var color,data = $now / Math.max($max,1) * 100;
	var color;

	if (data < 0) {
		var bkc;
		if (- data < 50) {
			return "<span class='life-bar' style='background:#ccc;width:" + (- data * 2) + "%'></span><span class='lifebar_text'>" + $now + "/" + $max + "</span>";
    	} else if( -data <= 100) {
			color = "#999";
			bkc = "#ccc";
			data = - data * 2 - 100;
		} else if( -data <= 150) {
			data = - data * 2 - 200;
			color = "#000";
			bkc = "#999";
		} else if( -data <= 150) {
			data = - data * 2 - 300;
			color = "#a00";
			bkc = "#000";
		} else {
			return "<span class='lifebar_text'>" + $now + "/" + $max + "</span>";
		}
		return "<span class='life-bar' style='background:" + bkc +";width:100%'></span><span class='life-bar' style='background:" + color + ";width:" + (data) + "%'></span><span class='lifebar_text'>" + $now + "/" + $max + "</span>";
	}

    if (data <= 25) {
      color = "#cc4444";
    } else if (data <= 50) {
      color = "#cccc00";
    } else if (data <= 75) {
      color = "#44cc44";
    } else {
      color = "#44cccc";
    }

    return "<span class='life-bar' style='background:" + color + ";width:" + data + "%'></span><span class='lifebar_text'>" + $now + "/" + $max + "</span>";
  }

  function ParamEditor(args) {
    var $from, $to, $picker, $max;
    var scope = this;
	var focusOutFlag = false;
	var ActiveCell = null;
	var TimeOutID = null;

	this.Num = function(text) {
		if (text === '' || text === void(0)) {
			return 0;
		} else {
			return parseInt(text.replace(/[０-９]/g,function(s){return String.fromCharCode(s.charCodeAt(0)-0xFEE0);}),10);
		}
	};

    this.init = function () {
      $from = $("<INPUT type='text' class='editor-life-from' />")
          .appendTo(args.container)
          .bind("keydown", scope.handleKeyDown);

      $(args.container).append("/");

      $to = $("<INPUT type=text class='editor-life-to' />")
          .appendTo(args.container)
          .bind("keydown", scope.handleKeyDown);

	  $picker = $("<div class='editor-life-helper'><div class='editor-life-wrapper'><div class='editor-life-buttons'><button>+1</button><button>-1</button><button>MAX</button><br /><button>+5</button><button>-5</button><br /><button>+10</button><button>-10</button></div></div></div>");
      $picker.find(".editor-life-buttons button").bind("click", function (e) {
        if ($(this).text() === 'MAX') {
			$from.val($to.val());
		} else if ($(this).text() === 'CHG') {
			$from.focus();
		} else if ($max.text() === 'MAX'){
			$from.val(parseInt($(this).text(),10) + scope.Num($from.val()));
			$from.focus();
		} else {
			$to.val(parseInt($(this).text(),10) + scope.Num($to.val()));
			$to.focus();
		}
      }).focus(function (e){focusOutFlag = true;});
	  $picker.bind("click", function (e) {
	  if(! $(e.target).is("button")){
	    args.commitChanges();
		args.cancelChanges();
		args.grid.resetActiveCell();
	  }
	  });
	  $picker.appendTo(document.body);
	  var pt = $from[0].getBoundingClientRect();
	  $picker.css({left:pt.x + 20,top:pt.y + pt.height + $(window).scrollTop()});
	  $max = $picker.find("button").eq(2);
	  $from.bind("focus",function(e) { focusOutFlag = true; $max.text('MAX'); });
	  $to.bind("focus",function(e) { focusOutFlag = true; $max.text('CHG'); });
	  $picker.bind('focus',function(e) {focusOutFlag = true;});
	  
      scope.focus();
	  $from.focusout(this.checkFocusout);
	  $to.focusout(this.checkFocusout);
	  
	  ActiveCell = args.grid.getActiveCell();
    };
	this.checkFocusout = function(e) {
		focusOutFlag = false;
		TimeOutID = window.setTimeout(scope.focusTimeOut,200);
	};
	
	this.focusTimeOut = function() {
		if (! focusOutFlag) {
			turnCell = args.grid.getActiveCell();
			if (turnCell === null) {
				args.grid.resetActiveCell();
			} else if (turnCell['row'] === ActiveCell['row'] && turnCell['cell'] === ActiveCell['cell']) {
				args.commitChanges();
				args.cancelChanges();
				args.grid.resetActiveCell();
			}
		}
		window.clearTimeout(TimeOutID);
		TimeOutID = null;
	}

    this.handleKeyDown = function (e) {
	  if (e.keyCode == $.ui.keyCode.TAB && $to.is(':focus')) {
		$from.focus();
		$from[0].setSelectionRange(0, $from.val().length);
		e.stopImmediatePropagation();
		return false;
	  }
      if (e.keyCode == $.ui.keyCode.LEFT || e.keyCode == $.ui.keyCode.RIGHT || e.keyCode == $.ui.keyCode.TAB) {
        e.stopImmediatePropagation();
      }
    };

    this.destroy = function () {
      $(args.container).empty();
      $picker.remove();
      $from.remove();
      $to.remove();
    };

    this.focus = function () {
		if (args.item[args.column.field] === '' || args.item[args.column.field] === void(0)) {
			$to.focus();
		} else {
			$from.focus();
		}
    };

    this.serializeValue = function () {
      return {from: scope.Num($from.val()), to: scope.Num($to.val())};
    };

    this.applyValue = function (item, state) {
      item[args.column.field] = state.from;
      item['/' + args.column.field] = state.to;
    };

    this.loadValue = function (item) {
      $from.val(item[args.column.field]);
      $to.val(item['/' + args.column.field]);
    };

    this.isValueChanged = function () {
      return args.item[args.column.field] != scope.Num($from.val()) || args.item['/' + args.column.field] != scope.Num($to.val());
    };

    this.validate = function () {
	  if (isNaN(scope.Num($from.val())) || isNaN(scope.Num($to.val()))) {
      	return {valid: false, msg: "数字でない文字が入力されました"};
      }
      return {valid: true, msg: null};
    };

    this.init();
  }
